## rclone 1.47.0+ex1

=== Makefile ===
SHELL = bash
BRANCH := $(or $(APPVEYOR_REPO_BRANCH),$(TRAVIS_BRANCH),$(shell git rev-parse --abbrev-ref HEAD))
LAST_TAG := $(shell git describe --tags --abbrev=0)
ifeq ($(BRANCH),$(LAST_TAG))
	BRANCH := master
endif
TAG_BRANCH := -$(BRANCH)
BRANCH_PATH := branch/
ifeq ($(subst HEAD,,$(subst master,,$(BRANCH))),)
	TAG_BRANCH :=
	BRANCH_PATH :=
endif
TAG := $(shell echo $$(git describe --abbrev=8 --tags | sed 's/-\([0-9]\)-/-00\1-/; s/-\([0-9][0-9]\)-/-0\1-/'))$(TAG_BRANCH)
NEW_TAG := $(shell echo $(LAST_TAG) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f.0", $$_)')
ifneq ($(TAG),$(LAST_TAG))
	TAG := $(TAG)-beta
endif
GO_VERSION := $(shell go version)
GO_FILES := $(shell go list ./... | grep -v /vendor/ )
BETA_PATH := $(BRANCH_PATH)$(TAG)
BETA_URL := https://beta.rclone.org/$(BETA_PATH)/
BETA_UPLOAD_ROOT := memstore:beta-rclone-org
BETA_UPLOAD := $(BETA_UPLOAD_ROOT)/$(BETA_PATH)
# Pass in GOTAGS=xyz on the make command line to set build tags
ifdef GOTAGS
BUILDTAGS=-tags "$(GOTAGS)"
LINTTAGS=--build-tags "$(GOTAGS)"
endif

.PHONY: rclone vars version

rclone:
	touch fs/version.go
	go install -v --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)" $(BUILDTAGS)
	cp -av `go env GOPATH`/bin/rclone .

vars:
	@echo SHELL="'$(SHELL)'"
	@echo BRANCH="'$(BRANCH)'"
	@echo TAG="'$(TAG)'"
	@echo LAST_TAG="'$(LAST_TAG)'"
	@echo NEW_TAG="'$(NEW_TAG)'"
	@echo GO_VERSION="'$(GO_VERSION)'"
	@echo BETA_URL="'$(BETA_URL)'"

version:
	@echo '$(TAG)'

# Full suite of integration tests
test:	rclone
	go install --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)" $(BUILDTAGS) github.com/ncw/rclone/fstest/test_all
	-test_all 2>&1 | tee test_all.log
	@echo "Written logs in test_all.log"

# Quick test
quicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) $(GO_FILES)

racequicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) -cpu=2 -race $(GO_FILES)

# Do source code quality checks
check:	rclone
	@# we still run go vet for -printfuncs which golangci-lint doesn't do yet
	@# see: https://github.com/golangci/golangci-lint/issues/204
	@echo "-- START CODE QUALITY REPORT -------------------------------"
	@go vet $(BUILDTAGS) -printfuncs Debugf,Infof,Logf,Errorf ./...
	@golangci-lint run $(LINTTAGS) ./...
	@echo "-- END CODE QUALITY REPORT ---------------------------------"

# Get the build dependencies
build_dep:
	go run bin/get-github-release.go -extract golangci-lint golangci/golangci-lint 'golangci-lint-.*\.tar\.gz'

# Get the release dependencies
release_dep:
	go get -u github.com/goreleaser/nfpm/...
	go get -u github.com/aktau/github-release

# Update dependencies
update:
	GO111MODULE=on go get -u ./...
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

doc:	rclone.1 MANUAL.html MANUAL.txt rcdocs commanddocs

rclone.1:	MANUAL.md
	pandoc -s --from markdown --to man MANUAL.md -o rclone.1

MANUAL.md:	bin/make_manual.py docs/content/*.md commanddocs backenddocs
	./bin/make_manual.py

MANUAL.html:	MANUAL.md
	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html

MANUAL.txt:	MANUAL.md
	pandoc -s --from markdown --to plain MANUAL.md -o MANUAL.txt

commanddocs: rclone
	XDG_CACHE_HOME="" XDG_CONFIG_HOME="" HOME="\$$HOME" USER="\$$USER" rclone gendocs docs/content/commands/

backenddocs: rclone bin/make_backend_docs.py
	./bin/make_backend_docs.py

rcdocs: rclone
	bin/make_rc_docs.sh

install: rclone
	install -d ${DESTDIR}/usr/bin
	install -t ${DESTDIR}/usr/bin ${GOPATH}/bin/rclone

clean:
	go clean ./...
	find . -name \*~ | xargs -r rm -f
	rm -rf build docs/public
	rm -f rclone fs/operations/operations.test fs/sync/sync.test fs/test_all.log test.log

website:
	cd docs && hugo

upload_website:	website
	rclone -v sync docs/public memstore:www-rclone-org

tarball:
	git archive -9 --format=tar.gz --prefix=rclone-$(TAG)/ -o build/rclone-$(TAG).tar.gz $(TAG)

sign_upload:
	cd build && md5sum rclone-v* | gpg --clearsign > MD5SUMS
	cd build && sha1sum rclone-v* | gpg --clearsign > SHA1SUMS
	cd build && sha256sum rclone-v* | gpg --clearsign > SHA256SUMS

check_sign:
	cd build && gpg --verify MD5SUMS && gpg --decrypt MD5SUMS | md5sum -c
	cd build && gpg --verify SHA1SUMS && gpg --decrypt SHA1SUMS | sha1sum -c
	cd build && gpg --verify SHA256SUMS && gpg --decrypt SHA256SUMS | sha256sum -c

upload:
	rclone -P copy build/ memstore:downloads-rclone-org/$(TAG)
	rclone lsf build --files-only --include '*.{zip,deb,rpm}' --include version.txt | xargs -i bash -c 'i={}; j="$$i"; [[ $$i =~ (.*)(-v[0-9\.]+-)(.*) ]] && j=$${BASH_REMATCH[1]}-current-$${BASH_REMATCH[3]}; rclone copyto -v "memstore:downloads-rclone-org/$(TAG)/$$i" "memstore:downloads-rclone-org/$$j"'

upload_github:
	./bin/upload-github $(TAG)

cross:	doc
	go run bin/cross-compile.go -release current $(BUILDTAGS) $(TAG)

beta:
	go run bin/cross-compile.go $(BUILDTAGS) $(TAG)
	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)
	@echo Beta release ready at https://pub.rclone.org/$(TAG)/

log_since_last_release:
	git log $(LAST_TAG)..

compile_all:
	go run bin/cross-compile.go -parallel 8 -compile-only $(BUILDTAGS) $(TAG)

appveyor_upload:
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)
endif
	@echo Beta release ready at $(BETA_URL)

circleci_upload:
	./rclone --config bin/travis.rclone.conf -v copy build/ $(BETA_UPLOAD)/testbuilds
ifndef BRANCH_PATH
	./rclone --config bin/travis.rclone.conf -v copy build/ $(BETA_UPLOAD_ROOT)/test/testbuilds-latest
endif
	@echo Beta release ready at $(BETA_URL)/testbuilds

BUILD_FLAGS := -exclude "^(windows|darwin)/"
ifeq ($(TRAVIS_OS_NAME),osx)
	BUILD_FLAGS := -include "^darwin/" -cgo
endif
ifeq ($(TRAVIS_OS_NAME),windows)
# BUILD_FLAGS := -include "^windows/" -cgo
# 386 doesn't build yet
	BUILD_FLAGS := -include "^windows/amd64" -cgo
endif

travis_beta:
ifeq ($(TRAVIS_OS_NAME),linux)
	go run bin/get-github-release.go -extract nfpm goreleaser/nfpm 'nfpm_.*\.tar.gz'
endif
	git log $(LAST_TAG).. > /tmp/git-log.txt
	go run bin/cross-compile.go -release beta-latest -git-log /tmp/git-log.txt $(BUILD_FLAGS) -parallel 8 $(BUILDTAGS) $(TAG)
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)
endif
	@echo Beta release ready at $(BETA_URL)

# Fetch the binary builds from travis and appveyor
fetch_binaries:
	rclone -P sync $(BETA_UPLOAD) build/

serve:	website
	cd docs && hugo server -v -w

tag:	doc
	@echo "Old tag is $(LAST_TAG)"
	@echo "New tag is $(NEW_TAG)"
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)\"\n" | gofmt > fs/version.go
	echo -n "$(NEW_TAG)" > docs/layouts/partials/version.html
	git tag -s -m "Version $(NEW_TAG)" $(NEW_TAG)
	bin/make_changelog.py $(LAST_TAG) $(NEW_TAG) > docs/content/changelog.md.new
	mv docs/content/changelog.md.new docs/content/changelog.md
	@echo "Edit the new changelog in docs/content/changelog.md"
	@echo "Then commit all the changes"
	@echo git commit -m \"Version $(NEW_TAG)\" -a -v
	@echo "And finally run make retag before make cross etc"

retag:
	git tag -f -s -m "Version $(LAST_TAG)" $(LAST_TAG)

startdev:
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(LAST_TAG)-DEV\"\n" | gofmt > fs/version.go
	git commit -m "Start $(LAST_TAG)-DEV development" fs/version.go

winzip:
	zip -9 rclone-$(TAG).zip rclone.exe

=== debian/changelog ===
rclone (1.47.0+ex1-6) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0
  * debhelper compatibility level 12
  * debian patch update_koofr_API_a35aa1360.patch applies upstream
    commit a35aa1360 updating for latest koofr API.

 -- Drew Parsons <dparsons@debian.org>  Thu, 01 Aug 2019 13:15:25 +0800

rclone (1.47.0+ex1-5) experimental; urgency=medium

  * Team upload.
  * allow 20 min for mips64el mipsel to complete TestTestsToRegexpLive

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 May 2019 18:08:39 +0800

rclone (1.47.0+ex1-4) experimental; urgency=medium

  * Team upload.
  * define dummy subdir ($CURDIR)/buildtest to use as home and cache
    for build-time tests

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 May 2019 15:49:20 +0800

rclone (1.47.0+ex1-3) experimental; urgency=medium

  * Team upload.
  * Versioned Depends: golang-github-ncw-swift-dev (>= 1.0.47)

 -- Drew Parsons <dparsons@debian.org>  Tue, 07 May 2019 14:47:31 +0800

rclone (1.47.0+ex1-2) experimental; urgency=medium

  * Team upload.
  * Depends, Build-Depends:
      golang-github-koofr-go-httpclient-dev
      golang-github-koofr-go-koofrclient-dev

 -- Drew Parsons <dparsons@debian.org>  Tue, 07 May 2019 13:50:41 +0800

rclone (1.47.0+ex1-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.47.0. Closes: #924745.
    - supports symlinks
    - supports DLNA servers (but support is disabled)
    - versioned dependencies:
      golang-github-abbot-go-http-auth-dev (>= 0.4.0)
      golang-github-dropbox-dropbox-sdk-go-unofficial-dev (>= 5.4.0)
      golang-google-api-dev (>= 0.1.0)
  * Debian patch disable_dlna.patch disables support for DLNA servers,
    since github/anacrolix/dms is not currently available in Debian.
    - exclude cmd/serve/dlna in debian/watch (repack as version "+ex1")

 -- Drew Parsons <dparsons@debian.org>  Tue, 07 May 2019 11:11:01 +0800

=== debian/control ===
Source: rclone
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 12),
               dh-golang,
               fuse,
               golang-any,
               golang-bazil-fuse-dev,
               golang-github-a8m-tree-dev,
               golang-github-abbot-go-http-auth-dev (>= 0.4.0),
               golang-github-aws-aws-sdk-go-dev,
               golang-github-azure-azure-storage-blob-go-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-djherbis-times-dev,
               golang-github-dropbox-dropbox-sdk-go-unofficial-dev (>= 5.4.0),
               golang-github-jlaffaye-ftp-dev,
               golang-github-koofr-go-httpclient-dev,
               golang-github-koofr-go-koofrclient-dev,
               golang-github-ncw-go-acd-dev,
               golang-github-ncw-swift-dev (>= 1.0.47),
               golang-github-nsf-termbox-go-dev,
               golang-github-okzk-sdnotify-dev,
               golang-github-patrickmn-go-cache-dev,
               golang-github-pkg-errors-dev,
               golang-github-rfjakob-eme-dev,
               golang-github-sevlyar-go-daemon-dev,
               golang-github-skratchdot-open-golang-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stretchr-testify-dev,
               golang-github-unknwon-goconfig-dev,
               golang-github-xanzy-ssh-agent-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-oauth2-google-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-text-dev,
               golang-golang-x-time-dev,
               golang-google-api-dev (>= 0.1.0)
Standards-Version: 4.4.0
Homepage: https://github.com/ncw/rclone
Vcs-Browser: https://salsa.debian.org/go-team/packages/rclone
Vcs-Git: https://salsa.debian.org/go-team/packages/rclone.git
XS-Go-Import-Path: github.com/ncw/rclone

Package: golang-github-ncw-rclone-dev
Section: devel
Architecture: all
Depends: golang-bazil-fuse-dev,
         golang-github-a8m-tree-dev,
         golang-github-abbot-go-http-auth-dev (>= 0.4.0),
         golang-github-aws-aws-sdk-go-dev,
         golang-github-azure-azure-storage-blob-go-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-djherbis-times-dev,
         golang-github-dropbox-dropbox-sdk-go-unofficial-dev (>= 5.4.0),
         golang-github-jlaffaye-ftp-dev,
         golang-github-koofr-go-httpclient-dev,
         golang-github-koofr-go-koofrclient-dev,
         golang-github-ncw-go-acd-dev,
         golang-github-ncw-swift-dev (>= 1.0.47),
         golang-github-nsf-termbox-go-dev,
         golang-github-okzk-sdnotify-dev (>= 0.0~git20180710.d9becc3-1),
         golang-github-patrickmn-go-cache-dev,
         golang-github-pkg-errors-dev,
         golang-github-rfjakob-eme-dev,
         golang-github-sevlyar-go-daemon-dev,
         golang-github-skratchdot-open-golang-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-stretchr-testify-dev,
         golang-github-unknwon-goconfig-dev,
         golang-github-xanzy-ssh-agent-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-oauth2-google-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-golang-x-time-dev,
         golang-google-api-dev (>= 0.1.0),
         ${misc:Depends},
         ${shlibs:Depends}
Description: go source code of rclone
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers.
 .
 This package contains rclone's source code.

Package: rclone
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: rsync for commercial cloud storage
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers:
 .
  - Google Drive
  - Amazon S3
  - Openstack Swift / Rackspace cloud files / Memset Memstore
  - Dropbox
  - Google Cloud Storage
  - Amazon Drive
  - Microsoft One Drive
  - Hubic
  - Backblaze B2
  - Yandex Disk

=== debian/rules ===
#!/usr/bin/make -f

# Do not build the qingstor and mega backends for now, the required
# go packages are not available yet.
export DH_GOLANG_EXCLUDES := backend/qingstor backend/mega

# Also install test data
export DH_GOLANG_INSTALL_EXTRA := \
	backend/alias/test \
	backend/drive/test \
	backend/http/test \
	cmd/lsf/testfiles \
	cmd/tree/testfiles

export BUILDTESTDIR=$(CURDIR)/buildtest

# some arches need more than 10 min to run TestTestsToRegexpLive
ARCHES_SLOW_TEST := mips64el mipsel
ifneq ($(findstring $(DEB_BUILD_ARCH),$(ARCHES_SLOW_TEST)),)
  EXTRA_TESTFLAGS := -timeout 20m
endif

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDTESTDIR)

# build-time tests for github.com/ncw/rclone/vfs access the config file
# so provide a null config
override_dh_auto_test:
	export XDG_CONFIG_HOME=$(BUILDTESTDIR); \
	export  XDG_CACHE_HOME=$(BUILDTESTDIR); \
	dh_auto_test -- $(EXTRA_TESTFLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/rclone-$1\.tar\.gz/, compression=xz, repack, dversionmangle=s/\+ex\d//, repacksuffix=+ex1" \
  https://github.com/ncw/rclone/tags .*/v?(\d\S+)\.tar\.gz

## rclone 1.50.2

=== Makefile ===
SHELL = bash
# Branch we are working on
BRANCH := $(or $(APPVEYOR_REPO_BRANCH),$(TRAVIS_BRANCH),$(BUILD_SOURCEBRANCHNAME),$(lastword $(subst /, ,$(GITHUB_REF))),$(shell git rev-parse --abbrev-ref HEAD))
# Tag of the current commit, if any.  If this is not "" then we are building a release
RELEASE_TAG := $(shell git tag -l --points-at HEAD)
# Version of last release (may not be on this branch)
VERSION := $(shell cat VERSION)
# Last tag on this branch
LAST_TAG := $(shell git describe --tags --abbrev=0)
# If we are working on a release, override branch to master
ifdef RELEASE_TAG
	BRANCH := master
endif
TAG_BRANCH := -$(BRANCH)
BRANCH_PATH := branch/
# If building HEAD or master then unset TAG_BRANCH and BRANCH_PATH
ifeq ($(subst HEAD,,$(subst master,,$(BRANCH))),)
	TAG_BRANCH :=
	BRANCH_PATH :=
endif
# Make version suffix -DDD-gCCCCCCCC (D=commits since last relase, C=Commit) or blank
VERSION_SUFFIX := $(shell git describe --abbrev=8 --tags | perl -lpe 's/^v\d+\.\d+\.\d+//; s/^-(\d+)/"-".sprintf("%03d",$$1)/e;')
# TAG is current version + number of commits since last release + branch
TAG := $(VERSION)$(VERSION_SUFFIX)$(TAG_BRANCH)
NEXT_VERSION := $(shell echo $(VERSION) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f.0", $$_)')
ifndef RELEASE_TAG
	TAG := $(TAG)-beta
endif
GO_VERSION := $(shell go version)
GO_FILES := $(shell go list ./... | grep -v /vendor/ )
ifdef BETA_SUBDIR
	BETA_SUBDIR := /$(BETA_SUBDIR)
endif
BETA_PATH := $(BRANCH_PATH)$(TAG)$(BETA_SUBDIR)
BETA_URL := https://beta.rclone.org/$(BETA_PATH)/
BETA_UPLOAD_ROOT := memstore:beta-rclone-org
BETA_UPLOAD := $(BETA_UPLOAD_ROOT)/$(BETA_PATH)
# Pass in GOTAGS=xyz on the make command line to set build tags
ifdef GOTAGS
BUILDTAGS=-tags "$(GOTAGS)"
LINTTAGS=--build-tags "$(GOTAGS)"
endif

.PHONY: rclone test_all vars version

rclone:
	go build -v --ldflags "-s -X github.com/rclone/rclone/fs.Version=$(TAG)" $(BUILDTAGS)
	mkdir -p `go env GOPATH`/bin/
	cp -av rclone`go env GOEXE` `go env GOPATH`/bin/

test_all:
	go install --ldflags "-s -X github.com/rclone/rclone/fs.Version=$(TAG)" $(BUILDTAGS) github.com/rclone/rclone/fstest/test_all

vars:
	@echo SHELL="'$(SHELL)'"
	@echo BRANCH="'$(BRANCH)'"
	@echo TAG="'$(TAG)'"
	@echo VERSION="'$(VERSION)'"
	@echo NEXT_VERSION="'$(NEXT_VERSION)'"
	@echo GO_VERSION="'$(GO_VERSION)'"
	@echo BETA_URL="'$(BETA_URL)'"

version:
	@echo '$(TAG)'

# Full suite of integration tests
test:	rclone test_all
	-test_all 2>&1 | tee test_all.log
	@echo "Written logs in test_all.log"

# Quick test
quicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) $(GO_FILES)

racequicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) -cpu=2 -race $(GO_FILES)

# Do source code quality checks
check:	rclone
	@echo "-- START CODE QUALITY REPORT -------------------------------"
	@golangci-lint run $(LINTTAGS) ./...
	@echo "-- END CODE QUALITY REPORT ---------------------------------"

# Get the build dependencies
build_dep:
	go run bin/get-github-release.go -extract golangci-lint golangci/golangci-lint 'golangci-lint-.*\.tar\.gz'

# Get the release dependencies
release_dep:
	go run bin/get-github-release.go -extract nfpm goreleaser/nfpm 'nfpm_.*_Linux_x86_64.tar.gz'
	go run bin/get-github-release.go -extract github-release aktau/github-release 'linux-amd64-github-release.tar.bz2'

# Update dependencies
update:
	GO111MODULE=on go get -u ./...
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

# Tidy the module dependencies
tidy:
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

doc:	rclone.1 MANUAL.html MANUAL.txt rcdocs commanddocs

rclone.1:	MANUAL.md
	pandoc -s --from markdown --to man MANUAL.md -o rclone.1

MANUAL.md:	bin/make_manual.py docs/content/*.md commanddocs backenddocs
	./bin/make_manual.py

MANUAL.html:	MANUAL.md
	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html

MANUAL.txt:	MANUAL.md
	pandoc -s --from markdown --to plain MANUAL.md -o MANUAL.txt

commanddocs: rclone
	XDG_CACHE_HOME="" XDG_CONFIG_HOME="" HOME="\$$HOME" USER="\$$USER" rclone gendocs docs/content/

backenddocs: rclone bin/make_backend_docs.py
	XDG_CACHE_HOME="" XDG_CONFIG_HOME="" HOME="\$$HOME" USER="\$$USER" ./bin/make_backend_docs.py

rcdocs: rclone
	bin/make_rc_docs.sh

install: rclone
	install -d ${DESTDIR}/usr/bin
	install -t ${DESTDIR}/usr/bin ${GOPATH}/bin/rclone

clean:
	go clean ./...
	find . -name \*~ | xargs -r rm -f
	rm -rf build docs/public
	rm -f rclone fs/operations/operations.test fs/sync/sync.test fs/test_all.log test.log

website:
	cd docs && hugo

upload_website:	website
	rclone -v sync docs/public memstore:www-rclone-org

tarball:
	git archive -9 --format=tar.gz --prefix=rclone-$(TAG)/ -o build/rclone-$(TAG).tar.gz $(TAG)

sign_upload:
	cd build && md5sum rclone-v* | gpg --clearsign > MD5SUMS
	cd build && sha1sum rclone-v* | gpg --clearsign > SHA1SUMS
	cd build && sha256sum rclone-v* | gpg --clearsign > SHA256SUMS

check_sign:
	cd build && gpg --verify MD5SUMS && gpg --decrypt MD5SUMS | md5sum -c
	cd build && gpg --verify SHA1SUMS && gpg --decrypt SHA1SUMS | sha1sum -c
	cd build && gpg --verify SHA256SUMS && gpg --decrypt SHA256SUMS | sha256sum -c

upload:
	rclone -P copy build/ memstore:downloads-rclone-org/$(TAG)
	rclone lsf build --files-only --include '*.{zip,deb,rpm}' --include version.txt | xargs -i bash -c 'i={}; j="$$i"; [[ $$i =~ (.*)(-v[0-9\.]+-)(.*) ]] && j=$${BASH_REMATCH[1]}-current-$${BASH_REMATCH[3]}; rclone copyto -v "memstore:downloads-rclone-org/$(TAG)/$$i" "memstore:downloads-rclone-org/$$j"'

upload_github:
	./bin/upload-github $(TAG)

cross:	doc
	go run bin/cross-compile.go -release current $(BUILDTAGS) $(TAG)

beta:
	go run bin/cross-compile.go $(BUILDTAGS) $(TAG)
	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)
	@echo Beta release ready at https://pub.rclone.org/$(TAG)/

log_since_last_release:
	git log $(LAST_TAG)..

compile_all:
	go run bin/cross-compile.go -compile-only $(BUILDTAGS) $(TAG)

appveyor_upload:
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)
endif
	@echo Beta release ready at $(BETA_URL)

circleci_upload:
	./rclone --config bin/travis.rclone.conf -v copy build/ $(BETA_UPLOAD)/testbuilds
ifndef BRANCH_PATH
	./rclone --config bin/travis.rclone.conf -v copy build/ $(BETA_UPLOAD_ROOT)/test/testbuilds-latest
endif
	@echo Beta release ready at $(BETA_URL)/testbuilds

travis_beta:
ifeq (linux,$(filter linux,$(subst Linux,linux,$(TRAVIS_OS_NAME) $(AGENT_OS))))
	go run bin/get-github-release.go -extract nfpm goreleaser/nfpm 'nfpm_.*\.tar.gz'
endif
	git log $(LAST_TAG).. > /tmp/git-log.txt
	go run bin/cross-compile.go -release beta-latest -git-log /tmp/git-log.txt $(BUILD_FLAGS) $(BUILDTAGS) $(TAG)
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)$(BETA_SUBDIR)
endif
	@echo Beta release ready at $(BETA_URL)

# Fetch the binary builds from travis and appveyor
fetch_binaries:
	rclone -P sync --exclude "/testbuilds/**" --delete-excluded $(BETA_UPLOAD) build/

serve:	website
	cd docs && hugo server -v -w

tag:	doc
	@echo "Old tag is $(VERSION)"
	@echo "New tag is $(NEXT_VERSION)"
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEXT_VERSION)\"\n" | gofmt > fs/version.go
	echo -n "$(NEXT_VERSION)" > docs/layouts/partials/version.html
	echo "$(NEXT_VERSION)" > VERSION
	git tag -s -m "Version $(NEXT_VERSION)" $(NEXT_VERSION)
	bin/make_changelog.py $(LAST_TAG) $(NEXT_VERSION) > docs/content/changelog.md.new
	mv docs/content/changelog.md.new docs/content/changelog.md
	@echo "Edit the new changelog in docs/content/changelog.md"
	@echo "Then commit all the changes"
	@echo git commit -m \"Version $(NEXT_VERSION)\" -a -v
	@echo "And finally run make retag before make cross etc"

retag:
	git tag -f -s -m "Version $(VERSION)" $(VERSION)

startdev:
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(VERSION)-DEV\"\n" | gofmt > fs/version.go
	git commit -m "Start $(VERSION)-DEV development" fs/version.go

winzip:
	zip -9 rclone-$(TAG).zip rclone.exe

=== debian/changelog ===
rclone (1.50.2-2ubuntu0.2) focal-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Fri, 20 Jan 2023 17:16:56 +0100

rclone (1.50.2-2ubuntu0.1) focal; urgency=medium

  * d/p/0008-fix-gdrive-download.patch: remove check for size, so google
    docs are identified solely by not having an MD5 checksum
    (LP: #1937136)
  * d/control: add missing build-depends for
    golang-github-mattn-go-colorable-dev (LP: #1966950)

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 29 Mar 2022 10:28:41 -0300

rclone (1.50.2-2) unstable; urgency=medium

  * Team upload.
  * mark usr/bin/build_csv as not-installed
    (it is an internal tool associated with rclone's info command)

 -- Drew Parsons <dparsons@debian.org>  Thu, 30 Jan 2020 12:14:40 +0800

rclone (1.50.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - applies 0006-Adapt-script-to-use-python3.patch
    - Build-Depends:
        golang-github-azure-azure-pipeline-go-dev (>= 0.2.2),
        golang-github-youmark-pkcs8-dev
  * Standards-Version: 4.5.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 22 Jan 2020 10:19:27 +0800

rclone (1.49.5-3) unstable; urgency=medium

  * Source-only upload.

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 29 Oct 2019 21:22:48 +0100

rclone (1.49.5-2) unstable; urgency=medium

  * No change upload to build against golang-github-jzelinskie-whirlpool-dev,
    version 0.0~git20170603.c19460b-2. The previous upload has been rejected
    because the field Built-Using referred to the -1 version of that package,
    which is no longer available in the ftp-master archive.

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 28 Oct 2019 20:56:23 +0100

rclone (1.49.5-1) unstable; urgency=medium

  [ Drew Parsons ]
  * update debian/copyright, debian/watch to stop excluding
    cmd/serve/dlna.

  [ Dr. Tobias Quathamer ]
  * New upstream version 1.49.5
    - Refresh patches
    - Remove patches which have been applied upstream
    - Rename -dev package to new upstream namespace
    - Add golang-github-atotto-clipboard-dev to Build-Depends
    - Add two new dependencies
    - Update bash completion for new release
    - Remove <script> to disable possible privacy breach
  * Update Standards-Version to 4.4.1, no changes needed
  * Remove README.Debian, is no longer relevant
  * Do not include installation instructions in manpage. (Closes: #941209)
    - Remove patch for manpage, is now obsolete
    - New patch for manpage
    - Add pandoc and python3 to Build-Depends
  * Add three test binaries to d/not-installed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 18 Oct 2019 00:57:22 +0200

rclone (1.47.0+ex1-7) unstable; urgency=medium

  * Team upload.
  * debian patch reinstate_dlna.patch reinstates support for DLNA
    servers (via dms). Drop disable_dlna.patch.
    Build-Depends: golang-github-anacrolix-dms-dev

 -- Drew Parsons <dparsons@debian.org>  Thu, 12 Sep 2019 00:49:23 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: rclone
 Section: net
 Priority: optional
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
 Build-Depends: bash-completion,
                debhelper-compat (= 12),
@@ -11,20 +12,26 @@
                golang-bazil-fuse-dev,
                golang-github-a8m-tree-dev,
                golang-github-abbot-go-http-auth-dev (>= 0.4.0),
+               golang-github-anacrolix-dms-dev,
+               golang-github-atotto-clipboard-dev,
                golang-github-aws-aws-sdk-go-dev,
+               golang-github-azure-azure-pipeline-go-dev (>= 0.2.2),
                golang-github-azure-azure-storage-blob-go-dev,
                golang-github-coreos-bbolt-dev,
                golang-github-djherbis-times-dev,
                golang-github-dropbox-dropbox-sdk-go-unofficial-dev (>= 5.4.0),
                golang-github-jlaffaye-ftp-dev,
+               golang-github-jzelinskie-whirlpool-dev,
                golang-github-koofr-go-httpclient-dev,
                golang-github-koofr-go-koofrclient-dev,
+               golang-github-mattn-go-colorable-dev,
                golang-github-ncw-go-acd-dev,
                golang-github-ncw-swift-dev (>= 1.0.47),
                golang-github-nsf-termbox-go-dev,
                golang-github-okzk-sdnotify-dev,
                golang-github-patrickmn-go-cache-dev,
                golang-github-pkg-errors-dev,
+               golang-github-putdotio-go-putio-dev,
                golang-github-rfjakob-eme-dev,
                golang-github-sevlyar-go-daemon-dev,
                golang-github-skratchdot-open-golang-dev,
@@ -33,31 +40,37 @@
                golang-github-stretchr-testify-dev,
                golang-github-unknwon-goconfig-dev,
                golang-github-xanzy-ssh-agent-dev,
+               golang-github-youmark-pkcs8-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-oauth2-google-dev,
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-golang-x-time-dev,
-               golang-google-api-dev (>= 0.1.0)
-Standards-Version: 4.4.0
-Homepage: https://github.com/ncw/rclone
+               golang-google-api-dev (>= 0.1.0),
+               pandoc,
+               python3
+Standards-Version: 4.5.0
+Homepage: https://github.com/rclone/rclone
 Vcs-Browser: https://salsa.debian.org/go-team/packages/rclone
 Vcs-Git: https://salsa.debian.org/go-team/packages/rclone.git
-XS-Go-Import-Path: github.com/ncw/rclone
+XS-Go-Import-Path: github.com/rclone/rclone
 
-Package: golang-github-ncw-rclone-dev
+Package: golang-github-rclone-rclone-dev
 Section: devel
 Architecture: all
 Depends: golang-bazil-fuse-dev,
          golang-github-a8m-tree-dev,
          golang-github-abbot-go-http-auth-dev (>= 0.4.0),
+         golang-github-anacrolix-dms-dev,
+         golang-github-atotto-clipboard-dev,
          golang-github-aws-aws-sdk-go-dev,
          golang-github-azure-azure-storage-blob-go-dev,
          golang-github-coreos-bbolt-dev,
          golang-github-djherbis-times-dev,
          golang-github-dropbox-dropbox-sdk-go-unofficial-dev (>= 5.4.0),
          golang-github-jlaffaye-ftp-dev,
+         golang-github-jzelinskie-whirlpool-dev,
          golang-github-koofr-go-httpclient-dev,
          golang-github-koofr-go-koofrclient-dev,
          golang-github-ncw-go-acd-dev,
@@ -66,6 +79,7 @@
          golang-github-okzk-sdnotify-dev (>= 0.0~git20180710.d9becc3-1),
          golang-github-patrickmn-go-cache-dev,
          golang-github-pkg-errors-dev,
+         golang-github-putdotio-go-putio-dev,
          golang-github-rfjakob-eme-dev,
          golang-github-sevlyar-go-daemon-dev,
          golang-github-skratchdot-open-golang-dev,

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,26 @@
 %:
 	dh $@ --buildsystem=golang --with=golang,bash-completion
 
+# The docs (MANUAL.md, MANUAL.html and rclone.1 manpage) all
+# contain information about the download and installation
+# of rclone. This is not useful for Debian.
+# The solution is a patch for the docs build system, then
+# regenerate the docs. See #941209.
+override_dh_install:
+	# Generate MANUAL.md
+	./bin/make_manual.py
+	# Generate HTML and manpage
+	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html
+	pandoc -s --from markdown --to man MANUAL.md -o rclone.1
+	# Now fix some lexgrog errors in the manpage:
+	# Remove the only line with .hy on it (near the top of the file)
+	sed -i -e "/^\.hy/d" rclone.1
+	# Use a proper NAME section header
+	sed -i -e "s/^\.SH Rclone/.SH NAME\nRclone/" rclone.1
+	# Finally, replace the first occurence of .PP with a section header
+	sed -i -e "1,/^\.PP/{s/\.PP/.SH DESCRIPTION/}" rclone.1
+	dh_install -O--buildsystem=golang
+
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf $(BUILDTESTDIR)
@@ -31,5 +51,5 @@
 # so provide a null config
 override_dh_auto_test:
 	export XDG_CONFIG_HOME=$(BUILDTESTDIR); \
-	export  XDG_CACHE_HOME=$(BUILDTESTDIR); \
+	export XDG_CACHE_HOME=$(BUILDTESTDIR); \
 	dh_auto_test -- $(EXTRA_TESTFLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/rclone-$1\.tar\.gz/, compression=xz, repack" \
  https://github.com/ncw/rclone/tags .*/v?(\d\S+)\.tar\.gz
